## ros-rolling-heaphook 0.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(heaphook)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
# uncomment the following section in order to fill in
# further dependencies manually.

find_package(tlsf REQUIRED)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  # the following line skips the linter which checks for copyrights
  # comment the line when a copyright and license is added to all source files
  set(ament_cmake_copyright_FOUND TRUE)
  # the following line skips cpplint (only works in a git repo)
  # comment the line when this package is in a git repo and when
  # a copyright and license is added to all source files
  set(ament_cmake_cpplint_FOUND TRUE)
  ament_lint_auto_find_test_dependencies()
endif()

add_executable(app src/app.cpp)

include(CheckSymbolExists)
check_symbol_exists(mallinfo2 malloc.h HAVE_MALLINFO2)

add_library(preloaded_heaptrack SHARED src/preloaded.cpp)
if(HAVE_MALLINFO2)
  target_compile_definitions(preloaded_heaptrack
    PRIVATE
      HAVE_MALLINFO2
  )
endif()

add_library(preloaded_tlsf SHARED src/preloaded_tlsf.cpp)
target_link_libraries(preloaded_tlsf PRIVATE tlsf::tlsf)
if(HAVE_MALLINFO2)
  target_compile_definitions(preloaded_tlsf
    PRIVATE
      HAVE_MALLINFO2
  )
endif()

install(TARGETS preloaded_heaptrack preloaded_tlsf DESTINATION lib)
install(TARGETS app DESTINATION bin)

ament_package()

=== debian/changelog ===
ros-rolling-heaphook (0.1.1-1jammy) jammy; urgency=high

  * fix: add workaround to build on ubuntu 20.04 (#5 <https://github.com/tier4/heaphook/issues/5>)
  * Contributors: Daisuke Nishimatsu

 -- sykwer <sykwer@gmail.com>  Fri, 11 Aug 2023 15:00:00 -0000

ros-rolling-heaphook (0.1.0-1jammy) jammy; urgency=high

  * ci: add build-and-test workflow (#2 <https://github.com/tier4/heaphook/issues/2>)
    * add build-and-test workflow
    * Update .github/workflows/build-and-test.yaml
    Co-authored-by: Kenji Miyake <mailto:31987104+kenji-miyake@users.noreply.github.com>
    * Update build-and-test.yaml
    * fix linter error
    * fix
    * fix
    * fix
    ---------
    Co-authored-by: Kenji Miyake <mailto:31987104+kenji-miyake@users.noreply.github.com>
  * style: apply lint (#1 <https://github.com/tier4/heaphook/issues/1>)
    * apply lint
    * refactor package.xml
    ---------
  * Update CMakeLists.txt
  * Update package.xml
  * Update package.xml metadata
  * Create LICENSE
  * Update README.md
  * Create README.md
  * Prevent infinit loop when additional mempool is not enough
  * Enable to configure mempool size
  * Delete unnecessary code
  * Hanble exhaustion of memory pool
  * Aquire lock for tlsf library
  * Fix bug
  * Add hooks for specialized malloc functions
  * Deal with alignment related functions
  * Fix
  * Introduce tlsf allocator
  * Create ament_cmake package
  * Add malloc_usable_size hook
  * Add aligned allocation hooks
  * Add realloc hook
  * Add calloc hook
  * Safe figure as pdf in heaplog parser
  * Add progress bar to heaplog parser
  * Add python heaplog parser
  * Change log format
  * Complete heaplog parser
  * Add mmaped log parser base
  * Fix bug (prevent logging in logging thread)
  * Make logging incremental and async
  * Log malloc/free history
  * Hook free
  * First malloc hook
  * Contributors: Daisuke Nishimatsu, Takahiro Ishikawa

 -- sykwer <sykwer@gmail.com>  Mon, 22 May 2023 15:00:00 -0000

=== debian/control ===
Source: ros-rolling-heaphook
Section: misc
Priority: optional
Maintainer: sykwer <sykwer@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-tlsf, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-heaphook
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-tlsf, ros-rolling-ros-workspace
Description: Replace all the dynamic heap allocation functions by LD_PRELOAD

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-heaphook//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install
